//---------------------------------------------------------------------------
// IFList Version 1.0
// Copyright (C) 2008 SHP Consulting & Systems
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
//---------------------------------------------------------------------------
#define WIN32
#define WPCAP
#define HAVE_REMOTE
#include <vcl.h>
#include <algorith.h>
#include <printers.hpp>
#include <WinPcap/pcap.h>
#include <Psdk/winsock2.h>
#include <Psdk/ws2tcpip.h>
#include <Psdk/windows.h>
#pragma hdrstop

int i = 0;
int j = 0;
int k = 0;
int NumListBoxItems = 0;
char String1[80];
char String2[80];
BOOL FIRST_INTERFACE = true;
char StringBuf[80];

#include "IFList1.h"
#include "IFList2.h"
#include "IFList3.h"
#include "IFList4.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent *Owner)
        : TForm(Owner)
{
  Application->OnHint = &OnHint;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::OnHint(TObject *Sender)
{
  StatusBar1->SimpleText = Application->Hint;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::OnPgmStartup(TObject *Sender)
{
  SplashScreen->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Run1Click(TObject *Sender)
{
  pcap_if_t *alldevs;
  pcap_if_t *d;
  char errbuf[PCAP_ERRBUF_SIZE + 1];
  char source[PCAP_ERRBUF_SIZE +1 ];
  char* cp = source;
  InputDialog->ShowModal();
  strcpy(cp, InputDialog->Edit1->Text.c_str());
  //
  // Check arguments.
  //
  int Edit1TextLength = InputDialog->Edit1->Text.Length();
  if (!Edit1TextLength > 0)
  {
    Application->NormalizeTopMosts();
    sprintf(StringBuf, "You did not enter the device you want to list.\nPlease try again.");
    Application->MessageBox(StringBuf, "Error", MB_OK);
    Application->RestoreTopMosts();
  }
  //
  // Retrieve the interfaces list.
  //
  if (pcap_findalldevs_ex(source, NULL, &alldevs, errbuf) == -1)
  {
    Application->NormalizeTopMosts();
    sprintf(StringBuf,"Error in pcap_findalldevs: %s\n",errbuf);
    Application->MessageBox(StringBuf, "Error", MB_OK);
    Application->RestoreTopMosts();
    exit(0);
  }
  //
  // Scan the list printing every entry.
  //
  for(d = alldevs; d; d = d->next)
  {
    if (FIRST_INTERFACE)
      FIRST_INTERFACE  = false;
    else
    {
      sprintf(StringBuf, "   ");
      ListBox1->Items->Add(StringBuf);
      NumListBoxItems++;
    }
    ifprint(d);
  }
  return;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Print1Click(TObject *Sender)
{
  if (NumListBoxItems == 0)
  {
    Application->NormalizeTopMosts();
    sprintf(StringBuf, "Screen is empty. Nothing to Print");
    Application->MessageBox(StringBuf, "Error", MB_OK);
    Application->RestoreTopMosts();
    return;
  };
  int result = PrintDialog1->Execute();
  if(result == mrOk)
  {
    TPrinter *APrinter = Printer();
    APrinter->BeginDoc();
    PrintScreen(APrinter->Canvas);
    APrinter->EndDoc();
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::About1Click(TObject *Sender)
{
  AboutDialog->ShowModal();
}
//---------------------------------------------------------------------------
//
// Print the screen's contents.
//
 void TMainForm::PrintScreen(TCanvas *Canvas)
{
  int x = 300;
  int y = 300;
  int RetCode;
  Canvas->Font->Name = "Arial";
  Canvas->Font->Color = clBlack;
  Canvas->Font->Size = 10;
  NumListBoxItems = NumListBoxItems - 1;
  for (i = 0; i <= NumListBoxItems; i++)
  {
    Canvas->TextOut(x, y, ListBox1->Items->Strings[i]);
    y = y + 64;
  }
}
//---------------------------------------------------------------------------
//
//  Display all the available information for the given interface.
//
void TMainForm::ifprint(pcap_if_t *d)
{
  pcap_addr_t *a;
  //
  // Interface's name, less "rcap://".
  //
  char *ptr;
  ptr = String1;
  strcpy(ptr, d->name);
  j = strlen(String1);
  for (i = 8; i <= j; i++)
  {
    String2[k] = String1[i];
    k++;
  }
  sprintf(StringBuf, "Name: %s", String2);
  ListBox1->Items->Add(StringBuf);
  NumListBoxItems++;
  //
  // Interface's description.
  //
  if (d->description)
    sprintf(StringBuf, "Description: %s", d->description);
  ListBox1->Items->Add(StringBuf);
  NumListBoxItems++;
  //
  // Interface's loopback address.
  //
  sprintf(StringBuf, "Loopback: %s", (d->flags & PCAP_IF_LOOPBACK)?"yes":"no");
  ListBox1->Items->Add(StringBuf);
  NumListBoxItems++;
  //
  // Interface's IP addresses.
  //
  for(a = d->addresses; a; a = a->next)
  {
    sprintf(StringBuf, "Address Family: #%d", a->addr->sa_family);
    ListBox1->Items->Add(StringBuf);
    NumListBoxItems++;
    switch(a->addr->sa_family)
    {
      case AF_INET:
         sprintf(StringBuf, "Address Family Name: AF_INET");
         ListBox1->Items->Add(StringBuf);
         NumListBoxItems++;
         if (a->addr)
         {
           sprintf(StringBuf, "Address: %s", iptos(((struct sockaddr_in *)a->addr)->sin_addr.s_addr));
           ListBox1->Items->Add(StringBuf);
           NumListBoxItems++;
         }
         if (a->netmask)
         {
           sprintf(StringBuf, "Netmask: %s", iptos(((struct sockaddr_in *)a->netmask)->sin_addr.s_addr));
           ListBox1->Items->Add(StringBuf);
           NumListBoxItems++;
         }
         if (a->broadaddr)
         {
           sprintf(StringBuf, "Broadcast Address: %s",iptos(((struct sockaddr_in *)a->broadaddr)->sin_addr.s_addr));
           ListBox1->Items->Add(StringBuf);
           NumListBoxItems++;
         }
         if (a->dstaddr)
         {
           sprintf(StringBuf, "Destination Address: %s",iptos(((struct sockaddr_in *)a->dstaddr)->sin_addr.s_addr));
           ListBox1->Items->Add(StringBuf);
           NumListBoxItems++;
         }
         break;
      case AF_INET6:
         sprintf(StringBuf, "Address Family Name: AF_INET6");
         ListBox1->Items->Add(StringBuf);
         NumListBoxItems++;
         if (a->addr)
         {
           sprintf(StringBuf, "Address: %s", iptos(((struct sockaddr_in *)a->addr)->sin_addr.s_addr));
           ListBox1->Items->Add(StringBuf);
           NumListBoxItems++;
         }
         if (a->netmask)
         {
           sprintf(StringBuf, "Netmask: %s", iptos(((struct sockaddr_in *)a->netmask)->sin_addr.s_addr));
           ListBox1->Items->Add(StringBuf);
           NumListBoxItems++;
         }
         if (a->broadaddr)
         {
           sprintf(StringBuf, "Broadcast Address: %s",iptos(((struct sockaddr_in *)a->broadaddr)->sin_addr.s_addr));
           ListBox1->Items->Add(StringBuf);
           NumListBoxItems++;
         }
         if (a->dstaddr)
         {
           sprintf(StringBuf, "Destination Address: %s",iptos(((struct sockaddr_in *)a->dstaddr)->sin_addr.s_addr));
           ListBox1->Items->Add(StringBuf);
           NumListBoxItems++;
         }
         break;
      default:
        sprintf(StringBuf, "Address Family Name: Unknown");
        ListBox1->Items->Add(StringBuf);
        NumListBoxItems++;
        break;
    }
  }
}
//---------------------------------------------------------------------------
//
// From tcptraceroute, convert a numeric IP address to a string
//
#define IPTOSBUFFERS    12
char * TMainForm::iptos(u_long in)
{
  static char output[IPTOSBUFFERS][3 * 4 + 3 + 1];
  static short which;
  u_char *p;
  p = (u_char *)&in;
  which = (which + 1 == IPTOSBUFFERS ? 0 : which + 1);
  sprintf(output[which], "%d.%d.%d.%d", p[0], p[1], p[2], p[3]);
  return output[which];
}
//---------------------------------------------------------------------------
